<template>
  <div
      id="seven-sidebar"
      class="hidden sticky top-0 z-[999] min-w-[260px] h-screen shadow-lg flex flex-col gap-3 p-2">
    <div
      class="border border-opacity-100 rounded p-2 flex items-center justify-center text-xl font-medium bg-primary cursor-pointer hover:!bg-primary-hover active:!bg-primary-active"
      @click="() => router.push('/')"
    >
      Svn Ui Library
    </div>

    <div class="w-full p-2 flex flex-col gap-2 border border-opacity-100 rounded">
      <svn-text
        base
      >
        Thèmes
      </svn-text>
      <v-select
        v-model="theme.global.name.value"
        :items="themeItems"
        variant="outlined"
        @update:model-value="updateTheme()"
        hide-details
      />
    </div>
    <div class="w-full p-2 flex flex-col gap-4 border border-opacity-100 rounded h-full overflow-hidden">
      <div class="flex flex-col gap-2">
        <svn-text
          base
          semi-bold
          class="text-center border-b p-2"
        >
          Components
        </svn-text>
        <v-text-field
          v-model="searchQuery"
          variant="outlined"
          label="Search component"
          hide-details
        />
      </div>
      <div
        class="overflow-y-auto h-fit"
      >
        <div
          v-for="item in filteredComposantItems"
        >
          <svn-text
            base
            semi-bold
            class="border-b cursor-pointer hover:bg-light-grey active:bg-middle-grey p-2 truncate"
            @click="() => { router.push(item.to)}"
          >
            {{ item.title }}
          </svn-text>
          <div class="p-2 pl-4 flex flex-col gap-2">
            <div
              v-for="sub_item in item.sub_items"
              class="border-l border-opacity-100 border-black p-1 pl-3 cursor-pointer hover:bg-light-grey active:bg-middle-grey truncate"
              @click="() => {
                router.push(item.to + sub_item.anchor)
                goTo(sub_item.anchor)
              }"
            >
              {{ sub_item.title }}
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import { useTheme } from "vuetify";
import { useRouter } from "vue-router";
import { computed, nextTick, onMounted, ref, watch } from "vue";

const theme = useTheme();
theme.global.name.value = "interview";

const router = useRouter()
const searchQuery = ref()

const themeItems = ref([
  {
    title: "Interview",
    value: "interview",
  },
  {
    title: "Roadmap",
    value: "roadmap",
  },
  {
    title: "Learn",
    value: "learn",
  },
  {
    title: "Company",
    value: "company",
  },
  {
    title: "Studio",
    value: "studio",
  }
])
const composantItems = ref([
  {
    title: "Animation",
    to: "/animation",
    sub_items: [
      {
        title: "SvnLoader",
        anchor: "#loader",
      },
    ]
  },
  {
    title: "Avatar",
    to: "/avatar",
    sub_items: [
      {
        title: "SvnAvatar",
        anchor: "#avatar",
      }
    ]
  },
  {
    title: "Button",
    to: "/button",
    sub_items: [
      {
        title: "Svn Floating Action Button",
        anchor: "#floating-action-button",
      },
      {
        title: "Svn Dots Button",
        anchor: "#dots-button",
      },
      {
        title: "Svn Button",
        anchor: "#button",
      },
      {
        title: "Svn Icon Button",
        anchor: "#icon-button",
      },
      {
        title: "Svn DropDown",
        anchor: "#dropdown",
      }
    ]
  },
  {
    title: "Card",
    to: "/card",
    sub_items: [
      {
        title: "Svn Studio Training Card",
        anchor: "#studio-training-card",
      },
    ]
  },
  {
    title: "Chip",
    to: "/chip",
    sub_items: [
      {
        title: "Svn Chip",
        anchor: "#chip",
      },
    ]
  },
  {
    title: "Dialog",
    to: "/dialog",
    sub_items: [
      {
        title: "Svn Dialog Import Profile Photo",
        anchor: "#dialog-import-profile-photo",
      },
      {
        title: "Svn Modal Manage People",
        anchor: "#modal-manage-people",
      },
    ]
  },
  {
    title: "Filter",
    to: "/filters",
    sub_items: [
      {
        title: "Svn Filter",
        anchor: "#filter",
      },
    ]
  },
  {
    title: "Input",
    to: "/input",
    sub_items: [
      {
        title: "Svn Auto complete",
        anchor: "#auto-complete",
      },
      {
        title: "Svn Switch",
        anchor: "#switch",
      },
    ]
  },
  {
    title: "List",
    to: "/list",
    sub_items: [
      {
        title: "Svn Studio Trainer List",
        anchor: "#studio-trainer-list",
      },
    ]
  },
  {
    title: "Login",
    to: "/login",
    sub_items: [
      {
        title: "Svn Login Card",
        anchor: "#login-card",
      },
    ]
  },
  {
    title: "Navbar",
    to: "/navbar",
    sub_items: [
      {
        title: "Svn Navbar",
        anchor: "#navbar",
      },
      {
        title: "Svn Navbar Menu",
        anchor: "#navbar-menu",
      },
    ]
  },
  {
    title: "Profile",
    to: "/profile",
    sub_items: [
      {
        title: "Svn Profile",
        anchor: "#profile",
      },
      {
        title: "Svn Profile Chip",
        anchor: "#profile-chip",
      },
      {
        title: "Svn Profile Table Cell",
        anchor: "#profile-table-cell",
      },
    ]
  },
  {
    title: "Skeleton",
    to: "/skeleton",
    sub_items: [
      {
        title: "Svn Dialog Skeleton",
        anchor: "#skeleton",
      },
      {
        title: "Svn Dialog Skeleton Card",
        anchor: "#skeleton-card",
      },
      {
        title: "Svn Index Skeleton",
        anchor: "#index-skeleton",
      },
      {
        title: "Svn Modal Skeleton",
        anchor: "#modal-skeleton",
      },
      {
        title: "Svn Modal Skeleton Card",
        anchor: "#modal-skeleton-card",
      },
    ]
  },
  {
    title: "Styles",
    to: "/styles",
    sub_items: [
      {
        title: "Svn Text",
        anchor: "#text",
      },
      {
        title: "Svn title",
        anchor: "#title",
      },
    ]
  },
  {
    title: "Table",
    to: "/table",
    sub_items: [
      {
        title: "Svn Data Table",
        anchor: "#data-table",
      },
    ]
  },
  {
    title: "Table Cell",
    to: "/table-cell",
    sub_items: [
      {
        title: "Svn Avatar Cell",
        anchor: "#avatar-cell",
      },
    ]
  },
  {
    title: "Pagination",
    to: "/pagination",
    sub_items: [
      {
        title: "Svn Pagination",
        anchor: "#pagination",
      },
    ]
  },
  {
    title: "Other",
    to: "/other",
    sub_items: [
      {
        title: "Svn Auto Complete Dropdown",
        anchor: "#auto-complete-dropdown",
      },
      {
        title: "Svn Center Content",
        anchor: "#center-content",
      },
      {
        title: "Svn Date Picker",
        anchor: "#date-picker",
      },
      {
        title: "Svn Timeline",
        anchor: "#timeline",
      },
      {
        title: "Svn Tooltip",
        anchor: "#tooltip",
      },
    ]
  },
  {
    title: "Editor",
    to: "/editor",
    sub_items: [
      {
        title: "Svn Editor",
        anchor: "#editor",
      },
    ]
  },
])

const search = (data, query) => {
  return query ? data.reduce((acc, item) => {
    const lowerCaseQuery = query.toLowerCase();
    let newItem = { ...item, sub_items: [] };

    if (item.title && item.title.toLowerCase().includes(lowerCaseQuery)) {
      newItem.sub_items = item.sub_items;
      acc.push(newItem);
    } else {
      const subItemsMatch = item.sub_items.filter(subItem => subItem.title && subItem.title.toLowerCase().includes(lowerCaseQuery));
      if (subItemsMatch.length > 0) {
        newItem.sub_items = subItemsMatch;
        // Check for existing entry
        const existingEntryIndex = acc.findIndex(accItem => accItem.title === item.title);
        if (existingEntryIndex !== -1) {
          acc[existingEntryIndex].sub_items = acc[existingEntryIndex].sub_items.concat(newItem.sub_items);
        } else {
          acc.push(newItem);
        }
      }
    }
    return acc;
  }, []) : data
}

const filteredComposantItems = computed(() => {
  return search(composantItems.value, searchQuery.value);
});


const goTo = (value) => {
  nextTick().then(() => {
    const hash = value.substring(1)

    if (hash) {
      const element = document.getElementById(hash);
      if (element) {
        element.scrollIntoView({ behavior: 'smooth' });
      }
    }
  })
}

const updateTheme = () => {
  localStorage.setItem('svn-library-theme', theme.global.name.value)
}
</script>